export declare type Option<T> = T | void;
export interface Transform<In, Out> {
    (source: In): Promise<Option<Out>>;
}
export interface Pipe<Context> extends Transform<Context, Context> {
}
export declare const unapplicable: Promise<void>;
export declare function never<Context>(ctx?: Context): Promise<void>;
export declare function always<Context>(ctx: Context): Promise<Context>;
export declare function bind<Context>(r: Promise<Option<Context>>, f: Pipe<Context>): Promise<Option<Context>>;
export declare function map<Context>(r: Promise<Option<Context>>, f: (ctx: Context) => Option<Context>): Promise<Option<Context>>;
export declare function compose<Context>(first: Pipe<Context>, second: Pipe<Context>): Pipe<Context>;
export declare function choose<Context>(parts: Array<Pipe<Context>>): Pipe<Context>;
export declare function chain<Context>(parts: Array<Pipe<Context>>): typeof never;
