"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.unapplicable = Promise.resolve(undefined);
function never(ctx) {
    return exports.unapplicable;
}
exports.never = never;
function always(ctx) {
    return Promise.resolve(ctx);
}
exports.always = always;
function bind(r, f) {
    return __awaiter(this, void 0, void 0, function () {
        var res, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, r];
                case 1:
                    res = _a.sent();
                    if (!res)
                        return [2 /*return*/, exports.unapplicable];
                    return [2 /*return*/, f(res)];
                case 2:
                    err_1 = _a.sent();
                    return [2 /*return*/, Promise.reject(err_1)];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.bind = bind;
function map(r, f) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, bind(r, function (ctx) {
                    var res = f(ctx);
                    return Promise.resolve(res);
                })];
        });
    });
}
exports.map = map;
function compose(first, second) {
    return function (ctx) { return bind(first(ctx), second); };
}
exports.compose = compose;
var chooseFrom = function (a, parts) { return __awaiter(_this, void 0, void 0, function () {
    var _i, parts_1, part, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _i = 0, parts_1 = parts;
                _a.label = 1;
            case 1:
                if (!(_i < parts_1.length)) return [3 /*break*/, 4];
                part = parts_1[_i];
                return [4 /*yield*/, part(a)];
            case 2:
                res = _a.sent();
                if (res)
                    return [2 /*return*/, res];
                _a.label = 3;
            case 3:
                _i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
function choose(parts) {
    if (parts.length === 0)
        return never;
    return function (ctx) { return chooseFrom(ctx, parts); };
}
exports.choose = choose;
function chain(parts) {
    if (parts.length === 0)
        return never;
    return parts.reduce(compose);
}
exports.chain = chain;
